@make(ais)
@aiInfo(topic=<An attempt to access an undefined constant is erroneous>,
number=[AI-00374/06],
classcode=[BI],
statuscode=[WJ],
mainref=[03.02.01@\(18)],
date=[88-05-23])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
!class binding interpretation 85-08-22
!status approved by WG9/AJPO 88-02-05
@end(toplines)
!status approved by Director, AJPO 88-02-05
!status approved by WG9/Ada Board 87-12-07
!status approved by Ada Board 87-07-30
!status panel/committee-approved 87-01-19 (reviewed)
!status panel/committee-approved (8-0-0) 86-11-13 (pending editorial review)
!status work-item 86-10-10
!status received 85-08-22
@references[!references @CommentNum[83-00616]83-00616, @CommentNum[83-00621]83-00621]
@topic{!topic @value(aitopic)}
@end(history)

@subheading[!summary 86-12-03]

The execution of a program is erroneous if it attempts to evaluate a scalar
@i[constant] with an undefined value.

@subheading[!question 87-01-19]

3.2.1(18) states:
@begin(quotation)
The execution  of a  program  is erroneous  if it  attempts  to
evaluate a scalar variable with an undefined value.
@end(quotation)
The following fragment evaluates a scalar constant with undefined value:
@begin(example)
@key[type] REC @key[is]
    @key[record]
        UNDEFINED : INTEGER;
    @key[end] @key[record];
R1 : REC;                    -- (1)
R2 : @key[constant] REC := R1;     -- (2)
...
... R2.UNDEFINED ...         -- (3)
@end(example)
R1.UNDEFINED is undefined at (1). Since R1 is non-scalar, evaluating R1 is
not erroneous at (2).  R2.UNDEFINED is undefined and used in an expression at
(3), but 3.2.1(18) does not apply, since R2.UNDEFINED is a constant, not a
variable.  Was this the intent?

@subheading[!recommendation 86-12-03]

The execution of a program is erroneous if it attempts to evaluate a scalar
@i[constant] with an undefined value.

@subheading[!discussion 86-10-13]

Evaluation of a scalar object having an undefined value was intended to be
erroneous.  Since constants must be initialized, 3.2.1(18) was written
assuming that all constants have defined values.  The example shows this is
not the case, so, to satisfy the intent, 3.2.1(18) should be understood to
apply as well to an attempt to evaluate a scalar constant with an undefined
value.

